#pragma semicolon 1

#include <sourcemod>
#include <cstrike>
#include <sdktools_functions>

public Plugin:myinfo = 
{
	name = "extend_round_time_1t",
	author = "wS / Schmidt",
	description = "Добавляет 'x' сек к времени раунда, если остался 1т (на de_ картах)",
	version = "1.3.1",
	url = "http://world-source.ru/"
};

new Handle:g_ForceRoundEndTimer;
new Handle:g_RoundExtendMsg;
new Handle:mp_ignore_round_win_conditions;
new g_extend_round_time_1t = 60;
new g_CtScore;
new bool:g_DE_map;
new bool:g_C4Planted;
new bool:g_RoundOn;

public OnPluginStart()
{
	mp_ignore_round_win_conditions = FindConVar("mp_ignore_round_win_conditions");
	SetConVarFlags(mp_ignore_round_win_conditions, GetConVarFlags(mp_ignore_round_win_conditions) & ~FCVAR_NOTIFY);

	HookConVarChange(CreateConVar("extend_round_time_1t", "60", "Сколько добавить секунд к времени раунда, если остался 1 Т", FCVAR_NOTIFY, true, 0.0), cvar);
	g_RoundExtendMsg = CreateConVar("extend_round_msg", "1", "1 - сообщение в чате 'на сколько сек продлен раунд', 0 - нет", FCVAR_NOTIFY, true, 0.0, true, 1.0);

	HookEvent("round_start",	round_start,	EventHookMode_PostNoCopy);
	HookEvent("round_end",		round_end);
	HookEvent("player_death",	player_death_or_team);
	HookEvent("player_team",	player_death_or_team);
	HookEvent("bomb_planted",	bomb_planted,	EventHookMode_PostNoCopy);
}

public cvar(Handle:var, const String:old[], const String:NewValue[]) g_extend_round_time_1t = StringToInt(NewValue);

///

public OnMapStart()
{
	g_ForceRoundEndTimer = INVALID_HANDLE;
	decl String:map[45]; GetCurrentMap(map, 45);
	g_DE_map = StrContains(map, "de_", false) == 0 ? true : false;
}

public round_start(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (g_DE_map)
	{
		g_RoundOn = true;
		g_C4Planted = false;
		if (g_ForceRoundEndTimer != INVALID_HANDLE)
		{
			KillTimer(g_ForceRoundEndTimer); g_ForceRoundEndTimer = INVALID_HANDLE;
		}
		SetConVarInt(mp_ignore_round_win_conditions, 0);
		g_CtScore = GetTeamScore(3);
	}
}

public round_end(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (g_DE_map) SetTeamScore(3, GetEventInt(event, "winner") == 3 ? g_CtScore + 1 : g_CtScore);
}

///

public Action:CS_OnTerminateRound(&Float:delay, &CSRoundEndReason:reason)
{
	if (g_DE_map && reason == CSRoundEnd_TargetSaved && g_ForceRoundEndTimer == INVALID_HANDLE && wS_NeedRoundExtend())
	{
		SetConVarInt(mp_ignore_round_win_conditions, 1);
		g_ForceRoundEndTimer = CreateTimer(float(g_extend_round_time_1t), g_ForceRoundEndTimer_CallBack, _, TIMER_REPEAT | TIMER_FLAG_NO_MAPCHANGE);
		if (GetConVarBool(g_RoundExtendMsg)) PrintToChatAll("\x04Раунд продлён на %d сек", g_extend_round_time_1t);
		CreateTimer(0.2, g_CtScore_Timer, _, TIMER_FLAG_NO_MAPCHANGE);
		return Plugin_Handled;
	}
	g_RoundOn = false;
	if (g_ForceRoundEndTimer != INVALID_HANDLE)
	{
		KillTimer(g_ForceRoundEndTimer); g_ForceRoundEndTimer = INVALID_HANDLE;
	}
	return Plugin_Continue;
}

public Action:g_ForceRoundEndTimer_CallBack(Handle:timer)
{
	if (g_RoundOn && !g_C4Planted)
	{
		g_RoundOn = false;
		g_ForceRoundEndTimer = INVALID_HANDLE;
		SetConVarInt(mp_ignore_round_win_conditions, 0);
		CS_TerminateRound(5.0, CSRoundEnd_TargetSaved, true);
		return Plugin_Stop;
	}
	return Plugin_Continue;
}

public Action:g_CtScore_Timer(Handle:timer) SetTeamScore(3, g_CtScore);

///

bool:wS_NeedRoundExtend()
{
	new t, ct, team;
	for (new i = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i) && IsPlayerAlive(i) && (team = GetClientTeam(i)) > 1)
		{
			if (team == 2)
			{
				if (++t > 1) return false;
			}
			else ct++;
		}
	}
	if (t == 1 && ct > 0) return true;
	return false;
}

public player_death_or_team(Handle:event, const String:name[], bool:dontBroadcast)
{
	// если раунд был продлен и игрок умер/вышел/сменил команду
	if (g_DE_map && g_RoundOn && g_ForceRoundEndTimer != INVALID_HANDLE)
	{
		new team = StrEqual(name, "player_team") ? GetEventInt(event, "oldteam") : GetClientTeam(GetClientOfUserId(GetEventInt(event, "userid")));
		if (team < 2) return;

		// если в команде нет живых, завершаем раунд (но если это тер и бомба установлена, ничего не делаем)
		new bool:found_alive_team_player = false;
		for (new i = 1; i <= MaxClients; i++)
		{
			if (IsClientInGame(i) && IsPlayerAlive(i) && GetClientTeam(i) == team)
			{
				found_alive_team_player = true;
				break;
			}
		}
		if (!found_alive_team_player && !(team == 2 && g_C4Planted))
		{
			g_RoundOn = false;
			SetConVarInt(mp_ignore_round_win_conditions, 0);
			CS_TerminateRound(5.0, team == 2 ? CSRoundEnd_TargetSaved : CSRoundEnd_TerroristWin, true);
			KillTimer(g_ForceRoundEndTimer); g_ForceRoundEndTimer = INVALID_HANDLE;
		}
	}
}

public bomb_planted(Handle:event, const String:name[], bool:dontBroadcast)
{
	g_C4Planted = true;
	SetConVarInt(mp_ignore_round_win_conditions, 0);
	if (g_ForceRoundEndTimer != INVALID_HANDLE)
	{
		KillTimer(g_ForceRoundEndTimer); g_ForceRoundEndTimer = INVALID_HANDLE;
	}
}

// wS